]>
Commit | Line | Data |
---|---|---|
b2e10493 AD |
1 | #!/bin/bash |
2 | # | |
3 | # test of qemu-img convert -n - convert without creation | |
4 | # | |
5 | # Copyright (C) 2009 Red Hat, Inc. | |
6 | # Copyright (C) 2013 Alex Bligh ([email protected]) | |
7 | # | |
8 | # This program is free software; you can redistribute it and/or modify | |
9 | # it under the terms of the GNU General Public License as published by | |
10 | # the Free Software Foundation; either version 2 of the License, or | |
11 | # (at your option) any later version. | |
12 | # | |
13 | # This program is distributed in the hope that it will be useful, | |
14 | # but WITHOUT ANY WARRANTY; without even the implied warranty of | |
15 | # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the | |
16 | # GNU General Public License for more details. | |
17 | # | |
18 | # You should have received a copy of the GNU General Public License | |
19 | # along with this program. If not, see <http://www.gnu.org/licenses/>. | |
20 | # | |
21 | ||
22 | # creator | |
23 | [email protected] | |
24 | ||
25 | seq=`basename $0` | |
26 | echo "QA output created by $seq" | |
27 | ||
28 | here=`pwd` | |
29 | tmp=/tmp/$$ | |
30 | status=1 # failure is the default! | |
31 | ||
32 | _cleanup() | |
33 | { | |
34 | _cleanup_test_img | |
fef9c191 | 35 | rm -f "$TEST_IMG.orig" "$TEST_IMG.raw" "$TEST_IMG.raw2" |
b2e10493 AD |
36 | } |
37 | trap "_cleanup; exit \$status" 0 1 2 3 15 | |
38 | ||
39 | # get standard environment, filters and checks | |
40 | . ./common.rc | |
41 | . ./common.filter | |
42 | . ./common.pattern | |
43 | ||
44 | _supported_fmt qcow qcow2 vmdk qed raw | |
1f7bf7d0 | 45 | _supported_proto file |
b2e10493 | 46 | _supported_os Linux |
d2329f27 FZ |
47 | _unsupported_imgopts "subformat=monolithicFlat" \ |
48 | "subformat=twoGbMaxExtentFlat" \ | |
49 | "subformat=twoGbMaxExtentSparse" | |
b2e10493 AD |
50 | |
51 | _make_test_img 4M | |
52 | ||
53 | echo "== Testing conversion with -n fails with no target file ==" | |
54 | # check .orig file does not exist | |
fef9c191 JC |
55 | rm -f "$TEST_IMG.orig" |
56 | if $QEMU_IMG convert -f $IMGFMT -O $IMGFMT -n "$TEST_IMG" "$TEST_IMG.orig" >/dev/null 2>&1; then | |
b2e10493 AD |
57 | exit 1 |
58 | fi | |
59 | ||
60 | echo "== Testing conversion with -n succeeds with a target file ==" | |
fef9c191 JC |
61 | rm -f "$TEST_IMG.orig" |
62 | cp "$TEST_IMG" "$TEST_IMG.orig" | |
63 | if ! $QEMU_IMG convert -f $IMGFMT -O $IMGFMT -n "$TEST_IMG" "$TEST_IMG.orig" ; then | |
b2e10493 AD |
64 | exit 1 |
65 | fi | |
66 | ||
67 | echo "== Testing conversion to raw is the same after conversion with -n ==" | |
68 | # compare the raw files | |
fef9c191 | 69 | if ! $QEMU_IMG convert -f $IMGFMT -O raw "$TEST_IMG" "$TEST_IMG.raw1" ; then |
b2e10493 AD |
70 | exit 1 |
71 | fi | |
72 | ||
fef9c191 | 73 | if ! $QEMU_IMG convert -f $IMGFMT -O raw "$TEST_IMG.orig" "$TEST_IMG.raw2" ; then |
b2e10493 AD |
74 | exit 1 |
75 | fi | |
76 | ||
fef9c191 | 77 | if ! cmp "$TEST_IMG.raw1" "$TEST_IMG.raw2" ; then |
b2e10493 AD |
78 | exit 1 |
79 | fi | |
80 | ||
81 | echo "== Testing conversion back to original format ==" | |
fef9c191 | 82 | if ! $QEMU_IMG convert -f raw -O $IMGFMT -n "$TEST_IMG.raw2" "$TEST_IMG" ; then |
b2e10493 AD |
83 | exit 1 |
84 | fi | |
85 | _check_test_img | |
86 | ||
87 | echo "== Testing conversion to a smaller file fails ==" | |
fef9c191 JC |
88 | rm -f "$TEST_IMG.orig" |
89 | mv "$TEST_IMG" "$TEST_IMG.orig" | |
b2e10493 | 90 | _make_test_img 2M |
fef9c191 | 91 | if $QEMU_IMG convert -f $IMGFMT -O $IMGFMT -n "$TEST_IMG.orig" "$TEST_IMG" >/dev/null 2>&1; then |
b2e10493 AD |
92 | exit 1 |
93 | fi | |
94 | ||
fef9c191 | 95 | rm -f "$TEST_IMG.orig" "$TEST_IMG.raw" "$TEST_IMG.raw2" |
b2e10493 AD |
96 | |
97 | echo "*** done" | |
98 | rm -f $seq.full | |
99 | status=0 | |
100 | exit 0 |